package network;

import java.util.ArrayList;

import Interfaces.LogInterface;

import node.Node;
import node.neuron.Neuron;

public class Network implements LogInterface {

	private ArrayList<Node> nodeList;
	private Object storingClass;
	
	public Network()
	{
		nodeList = new ArrayList<Node>();
		storingClass = null;
	}
	
	public final void addNode(Node node) throws Exception
	{
		if ( storingClass == null )
		{
			storingClass = node.getClassOfReference();
		}
		else 
		{
			if ( node.getClassOfReference() != storingClass )
			{
				System.err.println("[error] A network cannot store different nodes" ); 
				//System.exit(-1);
				return;
			}
		}
			
			
		nodeList.add(node);
	}
	
	public boolean checkNodeType ( Node node ) throws Exception
	{
		if ( node instanceof Neuron )
		{
			System.out.println("[test] Node is a Neuron.");				
		}
		else
		{
			System.out.println("[test] Node unknown");
			throw new Exception();
		}
		return true;
	}
	
	public void checkConsistency() 
	{
		for (Node node:nodeList )
		{
			try {
				checkNodeType(node);
			}
			catch ( Exception e )
			{
				System.err.println("[error] Unknown node in Network");
			}
		}
	}
	
	public final void displayInfo()
	{
		for (Node node:nodeList )
		{
			node.displayInfo();
		}
	}
}
